% Frobenious norm diagonal scaling example
%
% a numerical instance of the example in the book "Convex Optimization"
% by Boyd and Vandenberghe (page 163)
randn('state',0);

% matrix size (M is an n-by-n matrix)
n = 4;
M = randn(n,n);

% GP variables
gpvar d(n);

% objective
obj = posynomial;
for i = 1:n
  for j = 1:n
    obj = obj + M(i,j)^2*d(i)^2*d(j)^-2;
  end
end

[opt_frob_norm, solution, status] = gpsolve(obj,[]);

% optimal eigenvalue
opt_frob_norm
celldisp(solution)

% assign GP variables to their values (d now becomes an array of doubles)
assign(solution)

% construct matrix D
D = diag(d)
frob_norm_A_sqr = norm(D*M*inv(D),'fro')^2
