% box volume maximization example
%
% this is an example taken directly from the paper:
%
%   A Tutorial on Geometric Programming (see pages 8 and 13)
%   by Boyd, Kim, Vandenberghe, and Hassibi.
%
% problem constants
Awall  = 10000; Afloor = 1000;
alpha = 0.5; beta = 2; gamma = 0.5; delta = 2;

% GP variables
gpvar h w d

% objective function is the box volume
volume = h*w*d;

% set of constraints expressed as an array
constr = [ 2*(h*w + h*d) <= Awall; w*d <= Afloor;
           alpha <= h/w; h/w <= beta;
           gamma <= d/w; d/w <= delta;];

% solve the given GP problem
[max_volume solution status] = gpsolve(volume, constr, 'max')
