%----------------------------------------------------------------------
%
%       INFEASIBLE GP EXAMPLE
%
%----------------------------------------------------------------------
%
%   minimize:   x^-2 + y^-2
%   subject to: x^-1 <= 1
%               y^-1 <= 1
%               x + y <= 0.9
%
%   This problem has no feasible set.

clear all; close all;

%----------------------------------------------------------------------
%      PROBLEM DATA IN POSYNOMIAL FORM (DENSE FORMAT)
%----------------------------------------------------------------------

A = sparse(6,2);
  A(1,1) = -2;
  A(2,2) = -2;
  A(3,1) = -1;
  A(4,2) = -1;
  A(5,1) =  1;
  A(6,2) =  1;

b   = [ 1 1 1 1 1/0.9 1/0.9]';
szs = [ 2 1 1 2]';

%----------------------------------------------------------------------
%      SOLVE THE PROBLEM IN POSYNOMIAL FORM
%----------------------------------------------------------------------
[x1,status1,lambda1,nu1] = gpposy(A,b,szs);

%----------------------------------------------------------------------
%      SOLVE THE PROBLEM IN CONVEX FORM
%----------------------------------------------------------------------
[x2,status2,lambda2,nu2,mu2] = gpcvx(A,log(b),szs);

